#include "stdafx.h"
#include "mttermex.h"

using namespace XNSNET::Collections;
using namespace System;
using namespace System::Windows::Forms;
using namespace MetaTrader;
using namespace MetaTrader::Windows;

bool RetWindowException( Exception^ e ) {
	return ( (gcnew WindowException( e ))->ShowDialog( MainWindow::Current ) == DialogResult::Retry );
}

void ZeroString128( char* p ) {
	for( int i = 0; i < 16; i++ ) {
		((int*)p)[ i ] = 0x20202020;
	}
	p[ 128 ] = 0x00;
}

MTTERMEX BOOL WINAPI ContextInitialize( char* iContext, char* iSymbol ) {
Retry:
	try {
		Global::Context->Append( (IntPtr)iContext, gcnew String( iSymbol ) );
		iContext[ 0 ] = 0x00;
		Global::WindowControl();
		return TRUE;
	} catch( Exception^ e ) {
		if ( RetWindowException( e ) ) goto Retry;
	}
	return FALSE;
}

MTTERMEX BOOL WINAPI ContextFinalize( char* iContext ) {
Retry:
	try {
		Global::Context->Remove( (IntPtr)iContext );
		ZeroString128( iContext );
		Global::WindowControl();
		return TRUE;
	} catch( Exception^ e ) {
		if ( RetWindowException( e ) ) goto Retry;
	}
	return FALSE;
}

MTTERMEX BOOL WINAPI ClasterInit( char* iContext, char* iSymbol ) {
Retry:
	try {
		Context^ context = Global::Context->Append( (IntPtr)iContext, gcnew String( iSymbol ) );
		iContext[ 0 ] = 0x00;
		Global::WindowControl();
		return TRUE;
	} catch( Exception^ e ) {
		if ( RetWindowException( e ) ) goto Retry;
	}
	return FALSE;
}

MTTERMEX BOOL WINAPI ClasterStart( char* iContext, double iBid, double iAsk ) {
Retry:
	try {
		Context^ context = Global::Context[ (IntPtr)iContext ];
		return TRUE;
	} catch( Exception^ e ) {
		if ( RetWindowException( e ) ) goto Retry;
	}
	return FALSE;
}

MTTERMEX BOOL WINAPI ClasterDeinit( char* iContext ) {
Retry:
	try {
		Global::Context->Remove( (IntPtr)iContext );
		ZeroString128( iContext );
		Global::WindowControl();
		return TRUE;
	} catch( Exception^ e ) {
		if ( RetWindowException( e ) ) goto Retry;
	}
	return FALSE;
}