﻿namespace MetaTrader {

	using System;
	using System.Reflection;
	using XNSNET.Collections;

	public class ContextCollection: TemplatedList<ContextCollection, Context> {

		internal ContextCollection(): base() {}

		public Context this[ IntPtr iHandle ] {
			get {
				lock ( this ) {
					Context _Next = this.First;
					Context _Item;
					while ( _Next != null ) {
						_Item = _Next;
						_Next = _Next.Next;
						if ( _Item.Handle == iHandle )
							return _Item;
					}
				}
				return null;
			}
		}

		public Context Append( IntPtr iHandle, string iSymbol ) {
			if ( iHandle == IntPtr.Zero )
				throw new ArgumentNullException();
			if ( iSymbol == null )
				throw new ArgumentNullException();
			Context _Context = this[ iHandle ];
			if ( _Context != null ) return _Context;
			return AddFinal( new Context( iHandle, iSymbol ) );
		}

		public Context Remove( IntPtr iHandle ) {
			if ( iHandle == IntPtr.Zero )
				throw new ArgumentNullException();
			Context _Context = this[ iHandle ];
			if ( _Context != null ) {
				Remove( _Context );
			}
			return _Context;
		}

	}

	public class Context: TemplatedItem<ContextCollection, Context> {

		public readonly IntPtr Handle;
		public readonly string Symbol;

		internal Context( IntPtr iHandle, string iSymbol )
			: base() {
			Handle = iHandle;
			Symbol = iSymbol;
		}

		public override void OnRemoved() {

		}

	}

}